#include <hmg.ch>

function html_viewer( cHTMLFile )
   local cPath := ''
   private _cHTMLFile := ''
   if hb_uat( ':', cHTMLFile ) > 0
      // fullpath is available
   else   
      cPath := HB_CurDrive()+':\'+CurDir()+'\'
      cHTMLFile := cPath + cHTMLFile
   endif   
   _cHTMLFile := cHTMLFile
   if file( cHTMLFile )
      define window htmlview at 0, 0 width getdesktopwidth() - 100 height getdesktopheight() - 100 title 'Report Viewer' modal nosize 
         define toolbar toolbar1 imagewidth 24 imageheight 24 flat .t. strictwidth .t.
            button export  picture 'export' action exporthtmlview() tooltip 'Save the report to a HTML file' 
            button print  picture 'print' action printhtmlview() tooltip 'Print Report' separator
            button browser picture 'web' action openhtmlview() tooltip 'Open in Browser' separator
            button exit  picture 'exit' action htmlview.release() tooltip 'Exit'
         end toolbar
         DEFINE ACTIVEX Activex_1
            ROW    40
            COL    10
            WIDTH  getdesktopwidth() - 120
            HEIGHT getdesktopHeight() - 180
            PROGID "shell.explorer.2"
         END ACTIVEX   
         on key ESCAPE action htmlview.release
      end window
      htmlview.Activex_1.Object:Navigate( 'file:///' + cHTMLFile )
      htmlview.center
      htmlview.activate
   endif   
   return nil

function exporthtmlview
   local cNewFile := alltrim( PutFile ( { { "HTML Files (*.html)","*.html"}} , "Export to html file" ,  , .f. ) )
   if hb_uat( ".html", hmg_lower( cNewFile ) ) > 0
      if .not. hb_uright( hmg_lower( cNewFile ), 5 ) == ".html"
         cNewFile := cNewFile + ".html"
      endif
   else
      cNewFile := cNewFile + ".html"
   endif
   if file( cNewFile )
      if .not. msgyesno( 'File Already Exists! Do you want to overwrite?' )
         return nil
      endif
      ferase( cNewFile )
   endif   
   copy file &_cHTMLFile to &cNewFile
   return nil

function printhtmlview
   ShellExecute(nil, "print", 'file:///' + _cHTMLFile, nil, nil, 0)
return nil   

function openhtmlview
   execute file _cHTMLFile
return nil